<?php
  include("abins.php");
  include("guids.php");

  $abins = new abins_class;
//  $abins->setNHS();
  $abfiles = null;

  include("typelib.php");
  include("abwixfiles.php");

  echo "<html><body>";
  $handle = fopen($abins->output, "w");

  $s = wix_header();

  $abins->setTargetID("APPLICATIONROOTDIRECTORY");

  $mergeCRT = true;  // VCRT/MFC

  addApps();
  addCommon();
  add3rdParty();
  addPDF();
  addSpellEN();
  addINIs();

  addHelpEN();
  addTemplatesEN();

  wix_addfld("datafiles", "HTMLTemplate");
  wix_addfld("datafiles", "Patterns");
//  wix_addfld("july7bin", "abxsub");
  wix_addfld("datafiles", "Lang");

  $s .= wix_writefldrs();
  $s .= wix_writefiles();

  $s .= "\r\n";
  $s .= wix_str("<DirectoryRef Id='ApplicationProgramsFolder'>", 2);
  $s .= wix_str("<Component Id='ApplicationShortcut' Guid='" . get_guid() . "'>", 3);

  $s .= AppShortCut("Write");
  $s .= AppShortCut("Spread");
  $s .= AppShortCut("Pres");
//  $s .= AppShortCut("Data");
//  $s .= AppShortCut("Paint");
//  $s .= AppShortCut("Photo");
  $s .= wix_shortcut("Updates", "Check for Updates", "Check for updates to {$abins->title} online", "[SystemFolder]Rundll32", "", "ABShare,_CheckForUpdates@16");
  $s .= wix_shortcut("Reg", "Register Online", "Register {$abins->title} Online", "[SystemFolder]Rundll32", "", "ABShare,_RegisterOnline@16");
  $s .= wix_shortcut("Buy", "Purchase Options", "How to Buy {$abins->title}", "[SystemFolder]Rundll32", "", "ABShare,_HowToBuy@16");
  $s .= wix_shortcut("Support", "Online Support", "", "[SystemFolder]Rundll32", "", "ABShare,_TechnicalSupport@16");
  $s .= wix_shortcut("Manual", "User Guide", "{$abins->title} User Guide", "[SystemFolder]Rundll32", "", "ABShare,_UsersGuide@16");
  $s .= wix_shortcut("Uninstall", "Uninstall " . $abins->title, "Uninstalls " . $abins->title, "[SystemFolder]msiexec.exe", "", "/x [ProductCode]");

  $s .= wix_str("<RemoveFolder Id='ApplicationProgramsFolder' On='uninstall'/>", 4);
  $s .= wix_str("<RegistryValue Root='HKCU' Key='SOFTWARE\Ability 6.0\Common' Name='InstallDir' Value='[APPLICATIONROOTDIRECTORY]' Type='string' KeyPath='yes' />", 4);

  $s .= wix_str("</Component>", 3);

  $s .= wix_str("<Component Id='DesktopShortcut' Guid='" . get_guid() . "'>", 3);
  $s .= wix_str("<Condition>DESKTOP_ICONS</Condition>", 4);
  $s .= DesktopShortCut("Write");
  $s .= DesktopShortCut("Spread");
  $s .= DesktopShortCut("Pres");
//  $s .= DesktopShortCut("Data");
//  $s .= DesktopShortCut("Paint");
//  $s .= DesktopShortCut("Photo");
  $s .= wix_str("<RegistryValue Root='HKCU' Key='SOFTWARE\Ability 6.0\Common' Name='DesktopIcons' Value='1' Type='integer' KeyPath='yes' />", 4);
  $s .= wix_str("</Component>", 3);

  $s .= wix_str("</DirectoryRef>", 2);

  $s .= "

        <DirectoryRef Id='TARGETDIR'>
";
  if ($mergeCRT)
    $s .= mergeRef();

  $s .= "
            <Component Id='userRegistryEntries' Guid='ac021289-8904-e394-4571-edb6ecab0ace'>
                <RegistryKey Root='HKLM' Key='SOFTWARE\Ability 6.0\Common'>
                    <RegistryValue Name='InstallDir' Value='[APPLICATIONROOTDIRECTORY]' Type='string' />
                    <RegistryValue Name='showEULA' Value='0' Type='integer' />
                    <RegistryValue Name='tbStyle' Value='170582' Type='integer' />
                    <RegistryValue Name='SkinType' Value='5' Type='integer' />
                    <RegistryValue Name='tbSwitch' Value='170582' Type='integer' />
                    <RegistryValue Name='MatchOSLang' Value='1' Type='integer' />
                    <RegistryValue Name='UserName' Value='[USERNAME]' Type='string' />
                    <RegistryValue Name='Organization' Value='[COMPANYNAME]' Type='string' />
                    <RegistryValue Name='PID' Value='{$abins->PID}' Type='string' />
                    <RegistryValue Name='CheckMSFTAssocOnRun' Value='1' Type='integer' />
                    <RegistryValue Name='Textures' Value='[APPLICATIONROOTDIRECTORY]Patterns\' Type='string' />
                </RegistryKey>
            </Component>
            <Component Id='machineRegistryEntries' Guid='7363a249-c67c-12c4-6575-300b2d2837b3'>
                <RegistryKey Root='HKCU' Key='Software\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Compatibility Assistant\Persisted'>
                    <RegistryValue Type='integer' Name='[APPLICATIONROOTDIRECTORY]Install.exe' Value='1'/>
                </RegistryKey>
            </Component>
        </DirectoryRef>

        <Icon Id='icon.ico' SourceFile='\ab6\assets\launcher.ico'/>
        <Property Id='ARPPRODUCTICON' Value='icon.ico' />
";
 
    if ($mergeCRT)
      $s .= mergeFeature();


  $s .= "
        <Feature Id='MainApplication' Title='Main Application' Level='1'>
          <ComponentRef Id='userRegistryEntries' />
          <ComponentRef Id='machineRegistryEntries' />\n";

  $s .= wix_writecomponents();

  $s .="          <ComponentRef Id='ApplicationShortcut' />
          <ComponentRef Id='DesktopShortcut' />             
        </Feature>\n";

  $s .= "    <WixVariable Id='WixUILicenseRtf' Value='" . $abins->licrtf . "' Overridable='yes' />\n";
  $s .= "

    <UIRef Id='WixUI_InstallDir' />
    <Property Id='WIXUI_INSTALLDIR' Value='APPLICATIONROOTDIRECTORY' />
    <Property Id='WORD_ASSOC' Value='1' />
    <Property Id='SPREAD_ASSOC' Value='1' />
    <Property Id='PRES_ASSOC' Value='1' />
    <Property Id='DESKTOP_ICONS' Value='1' />

    <UI Id='MyWixUI_InstallDir'>
      <UIRef Id='WixUI_InstallDir' />
      <UIRef Id='WixUI_ErrorProgressText' />

      <DialogRef Id='FileAssoc' />

      <Publish Dialog='LicenseAgreementDlg' Control='Next' Event='NewDialog' Value='FileAssoc' Order='3'>LicenseAccepted = \"1\"</Publish>
      <Publish Dialog='InstallDirDlg' Control='Back' Event='NewDialog' Value='FileAssoc'>1</Publish>
    </UI>

  </Product>
</Wix>

";
  fwrite($handle, $s);
  fclose($handle);

  echo "<p>Done</p>";
//  print_pre($s);

  echo "<pre>";
  var_dump($strids);
  var_dump($abfiles);
  echo "</pre>";
  echo "</body></html>";

//////////////////////////////////

function print_pre($s) {
  $srch = array ("<", ">");
  $repl = array ("&lt", "&gt");
  $s = str_replace($srch, $repl, $s);
  echo "<pre>" . $s . "</pre>";
}

function wix_str($s, $level) {
  return indent($level) . $s . "\r\n";
}

// <Shortcut Id='ApplicationStartMenuShortcutWrite' Name='" . $abins->getProdstr("Write") . " 6' Description='" . $abins->getProdstr("Write") . "' Target='[APPLICATIONROOTDIRECTORY]Abwrite.exe' WorkingDirectory='APPLICATIONROOTDIRECTORY'/>

function appShortcut($id) {
global $abins;
  $name = $abins->getProdstr($id);
  if (in_array($id, array("Data", "Paint", "Photo")))
    $target = "[APPLICATIONROOTDIRECTORY]abxsub\\" . $abins->getExeName($id);
  else
    $target = "[APPLICATIONROOTDIRECTORY]" . $abins->getExeName($id);

  $s = wix_shortcut($id, $name . " 6", $name, $target, ""); 

  return $s;
}

// <Shortcut Id='ApplicationStartMenuShortcutWrite' Name='" . $abins->getProdstr("Write") . " 6' Description='" . $abins->getProdstr("Write") . "' Target='[APPLICATIONROOTDIRECTORY]Abwrite.exe' WorkingDirectory='APPLICATIONROOTDIRECTORY'/>

function DesktopShortCut($id) {
global $abins;
  $name = $abins->getProdstr($id);
  if (in_array($id, array("Data", "Paint", "Photo")))
    $target = "[APPLICATIONROOTDIRECTORY]abxsub\\" . $abins->getExeName($id);
  else
    $target = "[APPLICATIONROOTDIRECTORY]" . $abins->getExeName($id);

  $id = "DESKTOPSHORTCUT_" . strtoupper($id);
  $s = sprintf("%s<Shortcut Id='%s' Directory='DesktopFolder' Name='%s' Target='%s' WorkingDirectory='APPLICATIONROOTDIRECTORY'  />\r\n", indent(4), $id, $name, $target);
  return $s;
}


function wix_shortcut($id, $name, $description, $target, $working, $args = null) {
  $id = "SHORTCUTMENU_" . strtoupper($id);
  if (empty($description))
    $description = $name;
  if (empty($working))
    $working = "APPLICATIONROOTDIRECTORY";
  if ($args)
    return sprintf("%s<Shortcut Id='%s' Name='%s' Description='%s' Target='%s' WorkingDirectory='%s' Arguments='%s' />\r\n", indent(4), $id, $name, $description, $target, $working, $args);

  return sprintf("%s<Shortcut Id='%s' Name='%s' Description='%s' Target='%s' WorkingDirectory='%s' />\r\n", indent(4), $id, $name, $description, $target, $working);
}


function indent($level) {
  return str_repeat(" ", $level*4);
}


function wix_addfld($base, $target) {
  read_directory($base . "/" . $target, $base, $target);
}

function xslash($s) {
  return str_replace("/", "\\", $s);
}

function mergeRef() {
  $s = "
            <Merge Id='VCRedist' SourceFile='msm\Microsoft_VC100_CRT_x86.msm' DiskId='2' Language='0'/>
            <Merge Id='MFCRedist' SourceFile='msm\Microsoft_VC100_MFC_x86.msm' DiskId='2' Language='0'/>
  ";
  return $s;
}

function mergeFeature() {
  $s = "
        <Feature Id='VCRedist' Title='Visual C++ 2010 and MFC Runtime' AllowAdvertise='no' Display='hidden' Level='1'>
            <MergeRef Id='VCRedist'/>
            <MergeRef Id='MFCRedist'/>
        </Feature>
  ";
  return $s;

}

function read_directory($p_pathname, $base, $target) {
global $abins;

  $d = dir($p_pathname);

  $src = xslash($d->path);
  $target = substr($src, strlen($base)+1);
  $abins->setSrcFld($src);
  $abins->setTargetFld($target);

  echo "$target<br />\n";


  while (($file = $d->read()) !== false) {
    if (($file != ".") and ($file != "..")) {
      $filetype = filetype ("{$d->path}/{$file}");
      if ($filetype <> "dir") {
//        echo "&nbsp;&nbsp;{$d->path}/{$file}<br />";
        wix_addfile($file);
      }
    }
  }

  $d->rewind();

  while (($file = $d->read()) !== false) {
    if (($file != ".") and ($file != "..")) {
      $filetype = filetype ("{$d->path}/{$file}");
      if ($filetype == "dir") {
        read_directory ("{$d->path}/{$file}", $base, $target);
      }
    }
  }

  $d->close;
}

function fld_sort($a, $b) {
  $srch = array (" ", ".", "/", "\\");
  $repl = array ("", "", "", "");
  $s1 = str_replace("\\", "0", $a);
  $s2 = str_replace("\\", "0", $b);

  return strcmp($s1, $s2);
}

function wix_writefldrs() {
global $abfiles, $abins;

  $s   =  wix_str("<Directory Id='TARGETDIR' Name='SourceDir'>", 1);
  $s  .=  wix_str(  "<Directory Id='ProgramFilesFolder'>", 2);
  $s  .=  wix_str(    "<Directory Id='APPLICATIONROOTDIRECTORY' Name='" . $abins->dir . "' >", 3);
  $end  = wix_str(    "</Directory>", 3);
  $end .= wix_str(  "</Directory>", 2);
  $end .= wix_str(  "<Directory Id='ProgramMenuFolder'>", 2);
  $end .= wix_str(    "<Directory Id='ApplicationProgramsFolder' Name='" . $abins->menu . "' />", 3);
  $end .= wix_str(    "<Directory Id='DesktopFolder' Name='Desktop' />", 3);
  $end .= wix_str(  "</Directory>", 2);
  $end .= wix_str("</Directory>", 1);

  $p = null;  
  $x = null;
  foreach ($abfiles as $d) {
    if ($p <> $d->targetfld)
      $x[] = $d->targetfld;
    $p = $d->targetfld;
  }

  if (count($x) < 1)
    return $s . $end;

  usort($x, "fld_sort");

  echo "<pre>";
  var_dump($x);
  echo "</pre>";

  $depth = 0;
  $s_level_n = 0;
  $s_level_p = 0;
  $fmt = "%s<Directory Id='%s' Name='%s' %s\r\n";
  $fmt2 = "%s</Directory>\r\n";
  $t2 = explode("\\", $x[0]);    
  $n2 = count($t2);

  for ($i = 1; $i < count($x); $i++) {
    $has_sub = 1;
    $t1 = explode("\\", $x[$i-1]);    
    $t2 = explode("\\", $x[$i]);
    $n1 = count($t1);
    $n2 = count($t2);
    if ($n2 < $n1)
      $has_sub = 0;
    for ($j = 0; $j < min($n1, $n2); $j++) {
      if ($t1[$j] <> $t2[$j]) {
        $has_sub = 0;
        break;
      }
    }
    $s_level_n = $j;
    if ($has_sub) {
      $t = "";
      for ($j = 0; $j < $depth; $j++)
        $t .= $t1[$j] . "\\";
      for ($j = $depth; $j < $n1; $j++) {
        if (!empty($t) and substr($t, -1) <> "\\")
          $t .= "\\";
        $t .= $t1[$j];
        $s .= sprintf($fmt, indent($depth+4), str2fldid($t), $t1[$j], ">");
        $depth++;
      }
    }
    else {
      if ($n1 - $s_level_p > 1) {
        $t = "";
        for ($j = 0; $j < $depth; $j++)
          $t .= $t1[$j] . "\\";
        for ($j = $depth; $j < $n1 -1; $j++) {
          if (!empty($t) and substr($t, -1) <> "\\")
            $t .= "\\";
          $t .= $t1[$j];
          $s .= sprintf($fmt, indent($depth+4), str2fldid($t), $t1[$j], ">");
          $depth++;
        }
      }
      $s .= sprintf($fmt, indent($depth+4), str2fldid($x[$i-1]), $t1[$n1-1], "/>");
    }

    if ($s_level_n < $s_level_p) {
      for ($j = 0; $j < ($s_level_p - $s_level_n); $j++) {
        $depth--;
        $s .= sprintf($fmt2, indent($depth+4));
      }
    }
    if ($s_level_n == 0) {
      while ($depth > 0) {
        $depth--;
        $s .= sprintf($fmt2, indent($depth+4));
      }
    }
    $s_level_p = $s_level_n;
  }

  $j = 0;
  if ($n2 - $s_level_p > 1) {
    $t = "";
    for ($j = 0; $j < $depth; $j++)
      $t .= $t2[$j] . "\\";
    for ($j = $depth; $j < $n2 -1; $j++) {
      if (!empty($t) and substr($t, -1) <> "\\")
        $t .= "\\";
      $t .= $t2[$j];
      $s .= sprintf($fmt, indent($depth+4), str2fldid($t), $t2[$j], ">");
      $depth++;
    }
  }
  $s .= sprintf($fmt, indent($depth+4), str2fldid($x[count($x)-1]), $t2[$j], "/>");

  while ($depth > 0) {
    $depth--;
    $s .= sprintf($fmt2, indent($depth+4));
  }


  $s .= $end;
  return $s;
}

function wix_writefiles() {
global $abfiles, $typelib, $abins;

  $dirref = "";

  usort($abfiles, array("abfiles_class", "cmp_obj"));

  foreach ($abfiles as $x) {
    if ($dirref <> $x->targetID) {
      if (! empty($dirref))
        $s .= "        </DirectoryRef>\n";
      $dirref = $x->targetID;
      $s .= "\n\n        <DirectoryRef Id='$dirref'>\n";
    }

    $s .= $x->getCompStr();
    $s .= $x->getFileStr();

    switch ($x->getID()) {
      case "ABWordImpExDllID":
      case "ppt8fltDllID":
      case "A4w195DllID":
      case "abgfxDllID":
      case "abimgsrcDllID":
      case "abolepagesDllID":
      case "abchartDllID":
      case "ABImageXDllID";
      case "abdrwngsDllID":
      case "AbfieldDllID":
      case "phtmlexpDllID":
//        $s .= ">" . getinc($compid);
//        break;
       
      case "abwriteExeID":
      case "abspreadExeID":
      case "abpresentExeID":
        echo $x->getID() . "<br />";
        $s .= ">" . $typelib[$x->getID()];
        break;
      default:
        $s .= " />\n";
    }
    $s .= "          </Component>\n";
  }

  $s .= "        </DirectoryRef>\n";

  return $s;
}




function getinc($compid) {
global $wixfiles;
  $filepath = "typelib/" . basename($wixfiles[$compid][0], ".dll") . ".inc";
  if (filesize($filepath) < 1024) 
    return;
  $handle = fopen($filepath, "rb");
  if ($handle === false) {
    echo "Err";
    return;
  }

  $s = "";
  $t = "\r\n";
  $k = 0;
  while (($buffer = fgets($handle, 4096)) !== false) {
    $s = trim($buffer);
    if ($k == 1) {
      $t .= $buffer;
    }
    if (substr($s, 0, 7) == "</File>")
      $k = 0;
    if (substr($s, 0, 8) == "<File Id")
      $k = 1;
  }
  fclose($handle);

  return $t;

}

function wix_writecomponents() {
global $abfiles;
  $s = "";
  foreach ($abfiles as $comp)
    $s .= sprintf("          <ComponentRef Id='%s' />\n", $comp->getID());
  return $s;
}

function wix_addfile($f) {
global $abfiles, $abins;
  $dir = $abins->srcfld;

  $ldir = str_replace("\\", "/", $dir);
  if (! file_exists($ldir . "/" . $f))
    echo  "Warning $dir/$f not found<br />";

  $abfiles[] = new abfiles_class($f, $dir, $abins->targetfld, $abins->targetID, $abins->diskID);
}

function wix_addfile2($f) {
global $abfiles, $abins;
  $dir2 = $abins->srcfld;
  if (!empty($abins->altbin))
    $dir1 = $abins->altbin;
  else
    $dir1 = $dir2;

  $dir = $dir1;
  $ldir = str_replace("\\", "/", $dir1);
  if (! file_exists($ldir . "/" . $f)) {
    $dir = $dir2;
    $ldir = str_replace("\\", "/", $dir2);
    if (! file_exists($ldir . "/" . $f)) 
      echo  "Warning $dir2/$f not found<br />";
  }

  $abfiles[] = new abfiles_class($f, $dir, $abins->targetfld, $abins->targetID, $abins->diskID);
}


function wix_header() {
global $abins;

  $pid = get_guid();
  $upCode = get_guid();

  $s = wix_str("<?xml version='1.0' encoding='windows-1252'?>", 0);
  $s .= wix_str("<Wix xmlns='http://schemas.microsoft.com/wix/2006/wi'>", 0);

  
  $t = "<Product Name='" . $abins->title . "' Id='*' UpgradeCode='" . $upCode . "'
    Language='" . $abins->ln . "' Codepage='" . $abins->cp . "' Version='" . $abins->getver() . "' Manufacturer='" . $abins->co . "'>";
  $s .= wix_str($t, 1);

  $t = "<Package Id='*' Keywords='Installer' Description='" . $abins->title . " Installer'
        Comments='Version 6 WiX based installer' Manufacturer='" . $abins->co . "' InstallScope='perMachine' 
        InstallerVersion='300' Languages='" . $abins->ln . "' Compressed='yes' SummaryCodepage='" . $abins->cp . "' />
        <Media Id='1' Cabinet='ability6.cab' EmbedCab='yes' />
        <Media Id='2' Cabinet='mfcvcrt.cab' EmbedCab='no' />";
  $s .= wix_str($t, 1);

  $s .= "
    <MajorUpgrade DowngradeErrorMessage='A later version of [ProductName] is already installed. Setup will now exit.' />

    <Condition Message='[ProductName] requires Windows XP or later to run.'>
        <![CDATA[VersionNT>500]]>
    </Condition>

    <Binary Id='setupCA' SourceFile='abSetup5.dll'/>

    <CustomAction Id='PDFInstall'
                  BinaryKey='setupCA'
                  DllEntry='RegisterModules'
                  Execute='immediate'
                  Return='check'
                  HideTarget='no' />

    <CustomAction Id='PDFUnInstall'
                  BinaryKey='setupCA'
                  DllEntry='UninstallPDFDriver'
                  Execute='immediate'
                  Return='check'
                  HideTarget='no' />

    <InstallExecuteSequence>
      <Custom Action='PDFInstall' After='InstallFinalize'>Not Installed</Custom>
      <Custom Action='PDFUnInstall' Before='RemoveRegistryValues'>Installed AND REMOVE=\"ALL\"</Custom>
    </InstallExecuteSequence>


";

  return $s;

/*
No longer used...

    <CustomAction Id='msFileAssoc'
                  BinaryKey='setupCA'
                  DllEntry='SetMSExtensions'
                  Execute='immediate'
                  Return='check'
                  HideTarget='no' />

    <Custom Action='msFileAssoc' After='InstallFinalize'>Not Installed AND WORD_ASSOC</Custom>


*/

}


function str2fldid($s) {
  $s = strtoupper($s);
  $srch = array (" ", ".", "/", "\\");
  $repl = array ("_", "", "_", "_");
  $s = str_replace($srch, $repl, $s);
  
  return $s . "_FLD";
}


function uuid() {
  
   // The field names refer to RFC 4122 section 4.1.2

   return sprintf('%04x%04x-%04x-%03x4-%04x-%04x%04x%04x',
       mt_rand(0, 65535), mt_rand(0, 65535), // 32 bits for "time_low"
       mt_rand(0, 65535), // 16 bits for "time_mid"
       mt_rand(0, 4095),  // 12 bits before the 0100 of (version) 4 for "time_hi_and_version"
       bindec(substr_replace(sprintf('%016b', mt_rand(0, 65535)), '01', 6, 2)),
           // 8 bits, the last two of which (positions 6 and 7) are 01, for "clk_seq_hi_res"
           // (hence, the 2nd hex digit after the 3rd hyphen can only be 1, 5, 9 or d)
           // 8 bits for "clk_seq_low"
       mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535) // 48 bits for "node" 
   ); 
}


?>