<?php

function addApps() {
global $abins;
  set_setblock(20);

  wix_addfile2("abwrite.exe");
  wix_addfile2("abpresent.exe");
  wix_addfile2("abspread.exe");
//  wix_addfile2("ABPhoto.exe");
//  wix_addfile2("Abdraw.exe");
//  wix_addfile2("mxpaint.exe");
//  wix_addfile2("Abdata.exe");
  wix_addfile2("abenu.dll");
  wix_addfile2("Abshare.dll");
}

function addCommon() {
global $abins;
  set_setblock(40);
  wix_addfile("gbt.dll");
  wix_addfile("abo.dll");
  wix_addfile("abimgsrc.dll");
  wix_addfile("Abfield.dll");
  wix_addfile("ABIFXDll.dll");
  wix_addfile("ABMCmn.dll");
  wix_addfile("abpivot.dll");
  wix_addfile("ABTool.dll");
  wix_addfile("FilterHost.dll");
  wix_addfile("abimgfmt.dll");
  wix_addfile("image.dll");
  wix_addfile("phtmlexp.dll");
  wix_addfile("Vexx.dll");
  wix_addfile("Thxx.dll");
  wix_addfile("ABHTMLParser.dll");
  wix_addfile("abgfx.dll");
  wix_addfile("abow.dll");
  wix_addfile("abom.dll");
  wix_addfile("abdrwngs.dll");
  wix_addfile("abcomctrl.dll");
  wix_addfile("abcomdlg.dll");
  wix_addfile("abolepages.dll");
  wix_addfile("abchart.dll");
  wix_addfile("ABViewForms.dll");
  wix_addfile("AbCtls.dll");
  wix_addfile("ABImageX.dll");
  wix_addfile("ppt8flt.dll");
  wix_addfile("Abcells.dll");
  wix_addfile("FormEdit.exe");
  wix_addfile("WriteFX.dll");

  wix_addfile("abdbcmn.dll");
  wix_addfile("A4w195.dll");
  wix_addfile("abdrdll.dll");
  wix_addfile("ABSpel.dll");


  wix_addfile("ABCloudOps.dll");
  wix_addfile("ABWordImpEx.dll");
  wix_addfile("ablman.dll");
  wix_addfile("ooxct.dll");
  wix_addfile("ooxio.dll");
  wix_addfile("ooxst.dll");
  wix_addfile("ooxsupp.dll");
  wix_addfile("opc.dll");
  wix_addfile("xmlg.dll");

}

function add3rdParty() {
global $abins;
  $abins->setSrcFld("thirdparty");
  set_setblock(200);
  wix_addfile("Autorec.dll");
  wix_addfile("W019t32w.dll");
  wix_addfile("Auto32w.dll");
  wix_addfile("W019f32w.dll");
//  wix_addfile("ADPExt.dll"); COREL
  wix_addfile("Lektor52.dll");
  wix_addfile("ssce5532.dll");
  wix_addfile("SSCE5332.dll");
//  wix_addfile("msvcr100.dll");
//  wix_addfile("msvcp100.dll");
//  wix_addfile("mfc100u.dll");
//  wix_addfile("mfc100.dll");
//  wix_addfile("mfcm100.dll");
//  wix_addfile("mfcm100u.dll");
  wix_addfile("Office2007.cjstyles");
  wix_addfile("Vista.cjstyles");
  wix_addfile("WinXP.Luna.cjstyles");
  wix_addfile("WinXP.Royale.cjstyles");
  wix_addfile("Windows7.dll");
  wix_addfile("Office2010.dll");
  wix_addfile("Office2007.dll");
  wix_addfile("og10asu.dll");
  wix_addfile("libhunspell.dll");
  wix_addfile("RWUXThemeSU.dll");
  wix_addfile("en_US.aff");
  wix_addfile("en_US.dic");
  wix_addfile("SQLite3.dll");
}

function addPDF() {
global $abins;
  $abins->setSrcFld("thirdparty");

  set_setblock(300);
  wix_addfile("cdintf.dll");   // Common
  wix_addfile("Install.exe");
  wix_addfile("acfpdf.txt");
  wix_addfile("Install.ini");

//   wix_addfile("acfpdf.dll"); WIN NT4
//  wix_addfile("acfpdf.drv");  WIN 98/ME
//  wix_addfile("PluginTWAIN.dll"); ?

  wix_addfile("acfpdfui.dll");  // 32bit XP and above
  wix_addfile("acfpdfu.dll");

  wix_addfile("acfpdfuamd64.dll"); // 64bit XP and above
  wix_addfile("acfpdfuiamd64.dll");

//  wix_addfile("xmllite.dll");
//  wix_addfile("acpdfcrext.dll");
//  wix_addfile("pdfcreactivex.dll");
//  wix_addfile("acpdfcrdb.dll");
}

function addODF() {
global $abins;
  $abins->setSrcFld("bins\odf");

  wix_addfile('odf\zlibwapi.dll');
  wix_addfile('odf\License.txt');
  wix_addfile('odf\OdfZipUtils.dll');
  wix_addfile('odf\PresentationConverter.dll');
  wix_addfile('odf\OdfConverterLib.dll');
  wix_addfile('odf\PresentationConverter2Odf.dll');
  wix_addfile('odf\PresentationConverter2Oox.dll');
  wix_addfile('odf\SpreadsheetConverter.dll');
  wix_addfile('odf\SpreadsheetConverter2Odf.dll');
  wix_addfile('odf\SpreadsheetConverter2Oox.dll');
  wix_addfile('odf\WordprocessingConverter.dll');
  wix_addfile('odf\WordprocessingConverter2Odf.dll');
  wix_addfile('odf\WordprocessingConverter2Oox.dll');
  wix_addfile('odf\OdfConverter.exe', 89);
}

function addSpellEN() {
global $abins;
  $abins->setSrcFld("datafiles\spell_en");
  set_setblock(350);
  wix_addfile("THAMAA06.LEX");
  wix_addfile("THBRAA06.LEX");
  wix_addfile("sscebr.tlx");
  wix_addfile("ssceam.tlx");
  wix_addfile("ssceca.tlx");
  wix_addfile("ssceam2.clx");
  wix_addfile("ssceca2.clx");
  wix_addfile("sscebr2.clx");
  wix_addfile("autocorr.uk");
  wix_addfile("autocorr.us");
  wix_addfile("autocorr.ca");
}


function addINIs() {
global $abins;
  $abins->setSrcFld("datafiles");
  set_setblock(450);
  wix_addfile("Labels.sdb");
  wix_addfile("pivotss.xml");
}

function addHelpEN() {
global $abins;
  $abins->setSrcFld($abins->helpfld);
  $abins->setTargetFld("help");

  set_setblock(600);

  wix_addfile("abcs.chm");
  wix_addfile("writefx.chm");
  wix_addfile("ABFUNC.chm");
  wix_addfile("abpaint.chm");
  wix_addfile("ABDRAW.chm");
  wix_addfile("MACROS.chm");
  wix_addfile("ABWRITE.chm");
  wix_addfile("abphoto.chm");
  wix_addfile("ABLAUNCH.chm");
  wix_addfile("abpresent.chm");
  wix_addfile("SQLGUIDE.chm");
  wix_addfile("ABINTGRT.chm");
  wix_addfile("ABSPREAD.chm");
  wix_addfile("ABSHARED.chm");
  wix_addfile("abdata.chm");
  wix_addfile("drawtools.chm");
  wix_addfile("ABMANUAL.chm");
}

function addTemplatesEN() {
global $abins;
  $abins->setSrcFld("datafiles\\templates\\en");
  $abins->setTargetFld("templates\\en");

  set_setblock(1000);

  wix_addfile("cashflow.ast");
  wix_addfile("expenses.ast");
  wix_addfile("invoice.ast");
  wix_addfile("budget.ast");
  wix_addfile("loanAPR.ast");
  wix_addfile("businessletter.awp");
  wix_addfile("cv.awp");
  wix_addfile("fax.awp");
  wix_addfile("memo.awp");
  wix_addfile("resume.awp");
}

?>